Index: ta/branches/media_stripped/gui/configs/Falagard.xsd
===================================================================
--- /data/branches/media_stripped/gui/configs/Falagard.xsd	(revision 5591)
+++ 	(revision )
@@ -1,391 +1,0 @@
-<?xml version="1.0" ?>
-<xsd:schema xmlns:xsd="http://www.w3.org/2001/XMLSchema" elementFormDefault="qualified">
-	<xsd:element name="Falagard" type="falagardSpecificationType" />
-	<xsd:complexType name="falagardSpecificationType">
-		<xsd:sequence>
-			<xsd:element name="WidgetLook" type="widgetLookType" minOccurs="0" maxOccurs="unbounded" />
-		</xsd:sequence>
-	</xsd:complexType>
-	<xsd:complexType name="widgetLookType">
-		<xsd:sequence>
-            <xsd:element name="PropertyDefinition" type="propertyDefinitionType" minOccurs="0" maxOccurs="unbounded" />
-            <xsd:element name="PropertyLinkDefinition" type="propertyLinkDefinitionType" minOccurs="0" maxOccurs="unbounded" />
-            <xsd:element name="Property" type="propertyType" minOccurs="0" maxOccurs="unbounded" />
-            <xsd:element name="NamedArea" type="namedAreaType" minOccurs="0" maxOccurs="unbounded" />
-			<xsd:element name="Child" type="widgetComponentType" minOccurs="0" maxOccurs="unbounded" />
-			<xsd:element name="ImagerySection" type="imagerySectionType" minOccurs="0" maxOccurs="unbounded" />
-			<xsd:element name="StateImagery" type="stateType" minOccurs="0" maxOccurs="unbounded" />
-		</xsd:sequence>
-		<xsd:attribute name="name" type="xsd:string" use="required" />
-	</xsd:complexType>
-    <xsd:complexType name="propertyDefinitionType">
-        <xsd:attribute name="type" type="propertyTypeEnum" use="optional" default="Generic" />
-        <xsd:attribute name="name" type="xsd:string" use="required" />
-        <xsd:attribute name="initialValue" type="xsd:string" use="optional" default="" />
-        <xsd:attribute name="layoutOnWrite" type="xsd:boolean" use="optional" default="false" />
-        <xsd:attribute name="redrawOnWrite" type="xsd:boolean" use="optional" default="false" />
-    </xsd:complexType>
-    <xsd:complexType name="propertyLinkDefinitionType">
-        <xsd:attribute name="type" type="propertyTypeEnum" use="optional" default="Generic" />
-        <xsd:attribute name="name" type="xsd:string" use="required" />
-        <xsd:attribute name="widget" type="xsd:string" use="required" />
-        <xsd:attribute name="targetProperty" type="xsd:string" use="optional" default="" />
-        <xsd:attribute name="initialValue" type="xsd:string" use="optional" default="" />
-        <xsd:attribute name="layoutOnWrite" type="xsd:boolean" use="optional" default="false" />
-        <xsd:attribute name="redrawOnWrite" type="xsd:boolean" use="optional" default="false" />
-    </xsd:complexType>
-    <xsd:complexType name="namedAreaType">
-        <xsd:sequence>
-            <xsd:element name="Area" type="componentAreaType" />
-        </xsd:sequence>
-        <xsd:attribute name="name" type="xsd:string" use="required" />
-    </xsd:complexType>
-	<xsd:complexType name="stateType">
-		<xsd:sequence>
-			<xsd:element name="Layer" type="layerType" minOccurs="0" maxOccurs="unbounded" />
-		</xsd:sequence>
-		<xsd:attribute name="name" type="xsd:string" use="required" />
-        <xsd:attribute name="clipped" type="xsd:boolean" use="optional" default="true" />
-	</xsd:complexType>
-	<xsd:complexType name="layerType">
-		<xsd:sequence>
-			<xsd:element name="Section" type="sectionSpecType" minOccurs="0" maxOccurs="unbounded" />
-		</xsd:sequence>
-		<xsd:attribute name="priority" type="xsd:integer" use="optional" default="0" />
-	</xsd:complexType>
-    <xsd:complexType name="sectionSpecType">
-        <xsd:choice  minOccurs="0" maxOccurs="1">
-            <xsd:element name="Colour" type="colourType" />
-            <xsd:element name="Colours" type="colourRectType" />
-            <xsd:element name="ColourProperty" type="settingByPropertyType" />
-            <xsd:element name="ColourRectProperty" type="settingByPropertyType" />
-        </xsd:choice>
-        <xsd:attribute name="look" type="xsd:string" use="optional" default="" />
-        <xsd:attribute name="section" type="xsd:string" use="required" />
-        <xsd:attribute name="controlProperty" type="xsd:string" use="optional" default="" />
-    </xsd:complexType>
-	<xsd:complexType name="imagerySectionType">
-		<xsd:sequence>
-            <xsd:choice  minOccurs="0" maxOccurs="1">
-                <xsd:element name="Colour" type="colourType" />
-                <xsd:element name="Colours" type="colourRectType" />
-                <xsd:element name="ColourProperty" type="settingByPropertyType" />
-                <xsd:element name="ColourRectProperty" type="settingByPropertyType" />
-            </xsd:choice>
-            <xsd:element name="FrameComponent" type="frameComponentType" minOccurs="0" maxOccurs="unbounded" />
-			<xsd:element name="ImageryComponent" type="imageryComponentType" minOccurs="0" maxOccurs="unbounded" />
-            <xsd:element name="TextComponent" type="textComponentType" minOccurs="0" maxOccurs="unbounded" />
-		</xsd:sequence>
-		<xsd:attribute name="name" type="xsd:string" use="required" />
-	</xsd:complexType>
-    <xsd:complexType name="frameComponentType">
-        <xsd:sequence>
-            <xsd:element name="Area" type="componentAreaType" />
-            <xsd:element name="Image" type="frameImageType" minOccurs="0" maxOccurs="9" />
-            <xsd:choice  minOccurs="0" maxOccurs="1">
-                <xsd:element name="Colour" type="colourType" />
-                <xsd:element name="Colours" type="colourRectType" />
-                <xsd:element name="ColourProperty" type="settingByPropertyType" />
-                <xsd:element name="ColourRectProperty" type="settingByPropertyType" />
-            </xsd:choice>
-            <xsd:choice  minOccurs="0" maxOccurs="1">
-                <xsd:element name="VertFormat" type="vertFormatType" />
-                <xsd:element name="VertFormatProperty" type="settingByPropertyType" />
-            </xsd:choice>
-            <xsd:choice  minOccurs="0" maxOccurs="1">
-                <xsd:element name="HorzFormat" type="horzFormatType" />
-                <xsd:element name="HorzFormatProperty" type="settingByPropertyType" />
-            </xsd:choice>
-        </xsd:sequence>
-    </xsd:complexType>
-    <xsd:complexType name="textComponentType">
-        <xsd:sequence>
-            <xsd:element name="Area" type="componentAreaType" />
-            <xsd:element name="Text" type="textStringType" minOccurs="0" maxOccurs="1" />
-            <xsd:element name="TextProperty" type="textPropertyType" minOccurs="0" maxOccurs="1" />
-            <xsd:element name="FontProperty" type="fontPropertyType" minOccurs="0" maxOccurs="1" />
-            <xsd:choice  minOccurs="0" maxOccurs="1">
-                <xsd:element name="Colour" type="colourType" />
-                <xsd:element name="Colours" type="colourRectType" />
-                <xsd:element name="ColourProperty" type="settingByPropertyType" />
-                <xsd:element name="ColourRectProperty" type="settingByPropertyType" />
-            </xsd:choice>
-            <xsd:choice  minOccurs="0" maxOccurs="1">
-                <xsd:element name="VertFormat" type="vertTextFormatType" />
-                <xsd:element name="VertFormatProperty" type="settingByPropertyType" />
-            </xsd:choice>
-            <xsd:choice  minOccurs="0" maxOccurs="1">
-                <xsd:element name="HorzFormat" type="horzTextFormatType" />
-                <xsd:element name="HorzFormatProperty" type="settingByPropertyType" />
-            </xsd:choice>
-        </xsd:sequence>
-    </xsd:complexType>
-	<xsd:complexType name="imageryComponentType">
-		<xsd:sequence>
-			<xsd:element name="Area" type="componentAreaType" />
-            <xsd:choice>
-                <xsd:element name="Image" type="imageType" />
-                <xsd:element name="ImageProperty" type="settingByPropertyType" />
-            </xsd:choice>
-            <xsd:choice  minOccurs="0" maxOccurs="1">
-                <xsd:element name="Colour" type="colourType" />
-                <xsd:element name="Colours" type="colourRectType" />
-                <xsd:element name="ColourProperty" type="settingByPropertyType" />
-                <xsd:element name="ColourRectProperty" type="settingByPropertyType" />
-            </xsd:choice>
-            <xsd:choice  minOccurs="0" maxOccurs="1">
-                <xsd:element name="VertFormat" type="vertFormatType" />
-                <xsd:element name="VertFormatProperty" type="settingByPropertyType" />
-            </xsd:choice>
-            <xsd:choice  minOccurs="0" maxOccurs="1">
-                <xsd:element name="HorzFormat" type="horzFormatType" />
-                <xsd:element name="HorzFormatProperty" type="settingByPropertyType" />
-            </xsd:choice>
-		</xsd:sequence>
-	</xsd:complexType>
-	<xsd:complexType name="widgetComponentType">
-		<xsd:sequence>
-			<xsd:element name="Area" type="componentAreaType" />
-			<xsd:element name="VertAlignment" type="vertAlignmentType" minOccurs="0" maxOccurs="1" />
-			<xsd:element name="HorzAlignment" type="horzAlignmentType" minOccurs="0" maxOccurs="1" />
-			<xsd:element name="Property" type="propertyType" minOccurs="0" maxOccurs="unbounded" />
-		</xsd:sequence>
-		<xsd:attribute name="type" type="xsd:string" use="required" />
-		<xsd:attribute name="nameSuffix" type="xsd:string" use="required" />
-		<xsd:attribute name="renderer" type="xsd:string" use="optional" default="" />
-		<xsd:attribute name="look" type="xsd:string" use="optional" default="" />
-	</xsd:complexType>
-	<xsd:complexType name="horzFormatType">
-		<xsd:attribute name="type" type="horzFormatEnum" use="required" />
-	</xsd:complexType>
-	<xsd:complexType name="vertFormatType">
-		<xsd:attribute name="type" type="vertFormatEnum" use="required" />
-	</xsd:complexType>
-        <xsd:complexType name="horzTextFormatType">
-		<xsd:attribute name="type" type="horzTextFormatEnum" use="required" />
-	</xsd:complexType>
-	<xsd:complexType name="vertTextFormatType">
-		<xsd:attribute name="type" type="vertTextFormatEnum" use="required" />
-	</xsd:complexType>
-	<xsd:complexType name="horzAlignmentType">
-		<xsd:attribute name="type" type="horzAlignmentEnum" use="required" />
-	</xsd:complexType>
-	<xsd:complexType name="vertAlignmentType">
-		<xsd:attribute name="type" type="vertAlignmentEnum" use="required" />
-	</xsd:complexType>
-	<xsd:complexType name="propertyType">
-		<xsd:attribute name="name" type="xsd:string" use="required" />
-		<xsd:attribute name="value" type="xsd:string" use="required" />
-	</xsd:complexType>
-	<xsd:complexType name="imageType">
-		<xsd:attribute name="imageset" type="xsd:string" use="required" />
-		<xsd:attribute name="image" type="xsd:string" use="required" />
-	</xsd:complexType>
-    <xsd:complexType name="frameImageType">
-        <xsd:attribute name="type" type="frameImageComponentEnum" use="required" />
-        <xsd:attribute name="imageset" type="xsd:string" use="required" />
-        <xsd:attribute name="image" type="xsd:string" use="required" />
-    </xsd:complexType>
-	<xsd:complexType name="componentAreaType">
-        <xsd:choice>
-            <xsd:sequence>
-                <xsd:element name="Dim" type="dimensionType" minOccurs="4" maxOccurs="4" />
-            </xsd:sequence>
-            <xsd:element name="AreaProperty" type="settingByPropertyType" />
-        </xsd:choice>
-	</xsd:complexType>
-	<xsd:complexType name="dimensionType">
-		<xsd:choice>
-			<xsd:element name="UnifiedDim" type="unifiedDimType" />
-			<xsd:element name="AbsoluteDim" type="absoluteDimType" />
-			<xsd:element name="ImageDim" type="imageDimType" />
-            <xsd:element name="WidgetDim" type="widgetDimType" />
-            <xsd:element name="FontDim" type="fontDimType" />
-            <xsd:element name="PropertyDim" type="propertyDimType" />
-		</xsd:choice>
-		<xsd:attribute name="type" type="dimensionTypeEnum" use="required" />
-	</xsd:complexType>
-    <xsd:complexType name="fontDimType">
-        <xsd:sequence>
-            <xsd:element name="DimOperator" type="dimensionOperatorType" minOccurs="0" maxOccurs="1" />
-        </xsd:sequence>
-        <xsd:attribute name="widget" type="xsd:string" use="optional" default="" />
-        <xsd:attribute name="font" type="xsd:string" use="optional" default="" />
-        <xsd:attribute name="string" type="xsd:string" use="optional" default="" />
-        <xsd:attribute name="type" type="fontMetricTypeEnum" use="required" />
-        <xsd:attribute name="padding" type="xsd:decimal" use="optional" default="0" />
-    </xsd:complexType>
-    <xsd:complexType name="propertyDimType">
-        <xsd:sequence>
-            <xsd:element name="DimOperator" type="dimensionOperatorType" minOccurs="0" maxOccurs="1" />
-        </xsd:sequence>
-        <xsd:attribute name="widget" type="xsd:string" use="optional" default="" />
-        <xsd:attribute name="name" type="xsd:string" use="required" />
-    </xsd:complexType>
-	<xsd:complexType name="unifiedDimType">
-        <xsd:sequence>
-            <xsd:element name="DimOperator" type="dimensionOperatorType" minOccurs="0" maxOccurs="1" />
-        </xsd:sequence>
-		<xsd:attribute name="scale" type="xsd:decimal" use="optional" default="0" />
-		<xsd:attribute name="offset" type="xsd:integer" use="optional" default="0" />
-		<xsd:attribute name="type" type="dimensionTypeEnum" use="required" />
-	</xsd:complexType>
-	<xsd:complexType name="absoluteDimType">
-        <xsd:sequence>
-            <xsd:element name="DimOperator" type="dimensionOperatorType" minOccurs="0" maxOccurs="1" />
-        </xsd:sequence>
-		<xsd:attribute name="value" type="xsd:decimal" use="optional" default="0" />
-	</xsd:complexType>
-	<xsd:complexType name="imageDimType">
-        <xsd:sequence>
-            <xsd:element name="DimOperator" type="dimensionOperatorType" minOccurs="0" maxOccurs="1" />
-        </xsd:sequence>
-		<xsd:attribute name="imageset" type="xsd:string" use="required" />
-		<xsd:attribute name="image" type="xsd:string" use="required" />
-		<xsd:attribute name="dimension" type="dimensionTypeEnum" use="required" />
-	</xsd:complexType>
-	<xsd:complexType name="widgetDimType">
-        <xsd:sequence>
-            <xsd:element name="DimOperator" type="dimensionOperatorType" minOccurs="0" maxOccurs="1" />
-        </xsd:sequence>
-		<xsd:attribute name="widget" type="xsd:string" use="optional" default="" />
-		<xsd:attribute name="dimension" type="dimensionTypeEnum" use="required" />
-	</xsd:complexType>
-    <xsd:complexType name="settingByPropertyType">
-        <xsd:attribute name="name" type="xsd:string" use="required" />
-    </xsd:complexType>
-	<xsd:complexType name="colourRectType">
-		<xsd:attribute name="topLeft" type="colourValType" use="required" />
-		<xsd:attribute name="topRight" type="colourValType" use="required" />
-		<xsd:attribute name="bottomLeft" type="colourValType" use="required" />
-		<xsd:attribute name="bottomRight" type="colourValType" use="required" />
-	</xsd:complexType>
-	<xsd:complexType name="colourType">
-		<xsd:attribute name="colour" type="colourValType" use="required" />
-	</xsd:complexType>
-	<xsd:simpleType name="colourValType">
-		<xsd:restriction base="xsd:string">
-			<xsd:pattern value="[a-fA-F0-9]{8}" />
-		</xsd:restriction>
-	</xsd:simpleType>
-    <xsd:complexType name="textStringType">
-        <xsd:attribute name="string" type="xsd:string" use="optional" default="" />
-        <xsd:attribute name="font" type="xsd:string" use="optional" default="" />
-    </xsd:complexType>
-    <xsd:complexType name="textPropertyType">
-        <xsd:attribute name="name" type="xsd:string" use="required" />
-    </xsd:complexType>
-    <xsd:complexType name="fontPropertyType">
-        <xsd:attribute name="name" type="xsd:string" use="required" />
-    </xsd:complexType>
-    <xsd:complexType name="dimensionOperatorType">
-        <xsd:choice>
-            <xsd:element name="UnifiedDim" type="unifiedDimType" />
-            <xsd:element name="AbsoluteDim" type="absoluteDimType" />
-            <xsd:element name="ImageDim" type="imageDimType" />
-            <xsd:element name="WidgetDim" type="widgetDimType" />
-            <xsd:element name="FontDim" type="fontDimType" />
-            <xsd:element name="PropertyDim" type="propertyDimType" />
-        </xsd:choice>
-        <xsd:attribute name="op" type="dimensionOperatorEnum" use="required" />
-    </xsd:complexType>
-	<xsd:simpleType name="dimensionTypeEnum">
-		<xsd:restriction base="xsd:string">
-			<xsd:enumeration value="LeftEdge" />
-			<xsd:enumeration value="TopEdge" />
-			<xsd:enumeration value="RightEdge" />
-			<xsd:enumeration value="BottomEdge" />
-			<xsd:enumeration value="XPosition" />
-			<xsd:enumeration value="YPosition" />
-			<xsd:enumeration value="Width" />
-			<xsd:enumeration value="Height" />
-			<xsd:enumeration value="XOffset" />
-			<xsd:enumeration value="YOffset" />
-		</xsd:restriction>
-	</xsd:simpleType>
-	<xsd:simpleType name="vertFormatEnum">
-		<xsd:restriction base="xsd:string">
-			<xsd:enumeration value="TopAligned" />
-			<xsd:enumeration value="CentreAligned" />
-			<xsd:enumeration value="BottomAligned" />
-			<xsd:enumeration value="Stretched" />
-			<xsd:enumeration value="Tiled" />
-		</xsd:restriction>
-	</xsd:simpleType>
-	<xsd:simpleType name="horzFormatEnum">
-		<xsd:restriction base="xsd:string">
-			<xsd:enumeration value="LeftAligned" />
-			<xsd:enumeration value="CentreAligned" />
-			<xsd:enumeration value="RightAligned" />
-			<xsd:enumeration value="Stretched" />
-			<xsd:enumeration value="Tiled" />
-		</xsd:restriction>
-	</xsd:simpleType>
-	<xsd:simpleType name="vertAlignmentEnum">
-		<xsd:restriction base="xsd:string">
-			<xsd:enumeration value="TopAligned" />
-			<xsd:enumeration value="CentreAligned" />
-			<xsd:enumeration value="BottomAligned" />
-		</xsd:restriction>
-	</xsd:simpleType>
-	<xsd:simpleType name="horzAlignmentEnum">
-		<xsd:restriction base="xsd:string">
-			<xsd:enumeration value="LeftAligned" />
-			<xsd:enumeration value="CentreAligned" />
-			<xsd:enumeration value="RightAligned" />
-		</xsd:restriction>
-	</xsd:simpleType>
-    <xsd:simpleType name="horzTextFormatEnum">
-        <xsd:restriction base="xsd:string">
-            <xsd:enumeration value="LeftAligned" />
-            <xsd:enumeration value="RightAligned" />
-            <xsd:enumeration value="CentreAligned" />
-            <xsd:enumeration value="Justified" />
-            <xsd:enumeration value="WordWrapLeftAligned" />
-            <xsd:enumeration value="WordWrapRightAligned" />
-            <xsd:enumeration value="WordWrapCentreAligned" />
-            <xsd:enumeration value="WordWrapJustified" />
-        </xsd:restriction>
-    </xsd:simpleType>
-    <xsd:simpleType name="vertTextFormatEnum">
-        <xsd:restriction base="xsd:string">
-            <xsd:enumeration value="TopAligned" />
-            <xsd:enumeration value="BottomAligned" />
-            <xsd:enumeration value="CentreAligned" />
-        </xsd:restriction>
-    </xsd:simpleType>
-    <xsd:simpleType name="propertyTypeEnum">
-        <xsd:restriction base="xsd:string">
-            <xsd:enumeration value="Generic" />
-        </xsd:restriction>
-    </xsd:simpleType>
-    <xsd:simpleType name="fontMetricTypeEnum">
-        <xsd:restriction base="xsd:string">
-            <xsd:enumeration value="LineSpacing" />
-            <xsd:enumeration value="Baseline" />
-            <xsd:enumeration value="HorzExtent" />
-        </xsd:restriction>
-    </xsd:simpleType>
-    <xsd:simpleType name="dimensionOperatorEnum">
-        <xsd:restriction base="xsd:string">
-            <xsd:enumeration value="Noop" />
-            <xsd:enumeration value="Add" />
-            <xsd:enumeration value="Subtract" />
-            <xsd:enumeration value="Multiply" />
-            <xsd:enumeration value="Divide" />
-        </xsd:restriction>
-    </xsd:simpleType>
-    <xsd:simpleType name="frameImageComponentEnum">
-        <xsd:restriction base="xsd:string">
-            <xsd:enumeration value="Background" />
-            <xsd:enumeration value="TopLeftCorner" />
-            <xsd:enumeration value="TopRightCorner" />
-            <xsd:enumeration value="BottomLeftCorner" />
-            <xsd:enumeration value="BottomRightCorner" />
-            <xsd:enumeration value="LeftEdge" />
-            <xsd:enumeration value="RightEdge" />
-            <xsd:enumeration value="TopEdge" />
-            <xsd:enumeration value="BottomEdge" />
-        </xsd:restriction>
-    </xsd:simpleType>
-</xsd:schema>
Index: ta/branches/media_stripped/gui/configs/Font.xsd
===================================================================
--- /data/branches/media_stripped/gui/configs/Font.xsd	(revision 5591)
+++ 	(revision )
@@ -1,34 +1,0 @@
-<?xml version="1.0" ?>
-<xsd:schema xmlns:xsd="http://www.w3.org/2001/XMLSchema" elementFormDefault="qualified">
-	<xsd:element name="Font" type="FontType" />
-
-	<xsd:complexType name="FontType">
-		<xsd:sequence>
-			<xsd:element name="Mapping" type="MapType" maxOccurs="unbounded" minOccurs="0" />
-		</xsd:sequence>
-		<xsd:attributeGroup ref="FontAttrs" />
-	</xsd:complexType>
-	<xsd:complexType name="MapType">
-		<xsd:attribute name="Codepoint" type="xsd:nonNegativeInteger" use="required" />
-		<xsd:attribute name="Image" type="xsd:string" use="required" />
-		<xsd:attribute name="HorzAdvance" type="xsd:integer" use="optional" default="-1" />
-	</xsd:complexType>
-	<xsd:attributeGroup name="FontAttrs">
-		<xsd:attribute name="Name" type="xsd:string" use="required" />
-		<xsd:attribute name="Filename" type="xsd:string" use="required" />
-		<xsd:attribute name="ResourceGroup" type="xsd:string" use="optional"  default="" />
-		<xsd:attribute name="Type" use="required">
-			<xsd:simpleType>
-				<xsd:restriction base="xsd:string">
-					<xsd:enumeration value="FreeType" />
-					<xsd:enumeration value="Pixmap" />
-				</xsd:restriction>
-			</xsd:simpleType>
-		</xsd:attribute>
-		<xsd:attribute name="Size" type="xsd:nonNegativeInteger" use="optional" default="12" />
-		<xsd:attribute name="NativeHorzRes" type="xsd:nonNegativeInteger" use="optional" default="640" />
-		<xsd:attribute name="NativeVertRes" type="xsd:nonNegativeInteger" use="optional" default="480" />
-		<xsd:attribute name="AutoScaled" type="xsd:boolean" use="optional" default="false" />
-		<xsd:attribute name="AntiAlias" type="xsd:boolean" use="optional" default="true" />
-	</xsd:attributeGroup>
-</xsd:schema>
Index: ta/branches/media_stripped/gui/configs/GUILayout.xsd
===================================================================
--- /data/branches/media_stripped/gui/configs/GUILayout.xsd	(revision 5591)
+++ 	(revision )
@@ -1,63 +1,0 @@
-<?xml version="1.0"?>
-<xsd:schema xmlns:xsd="http://www.w3.org/2001/XMLSchema" elementFormDefault="qualified">
-
-	<xsd:element name="GUILayout" type="GUILayoutType"/>
-	
-	<xsd:complexType name="GUILayoutType">
-		<xsd:sequence>
-			<xsd:element name="Window" type="WindowType" />
-		</xsd:sequence>
-		<xsd:attribute name="Parent" type="xsd:string" use="optional" default=""/>
-	</xsd:complexType>
-	
-	<xsd:complexType name="WindowType">
-		<xsd:sequence>
-			<xsd:element name="LayoutImport" type="LayoutImportType"  minOccurs="0" maxOccurs="unbounded" />
-			<xsd:element name="Property" type="PropertyType"  minOccurs="0" maxOccurs="unbounded" />
-			<xsd:element name="Event" type="EventType"  minOccurs="0" maxOccurs="unbounded" />
-			<xsd:choice minOccurs="0" maxOccurs="unbounded">
-				<xsd:element name="Window" type="WindowType" />
-				<xsd:element name="AutoWindow" type="AutoWindowType" />
-			</xsd:choice>
-			<xsd:element name="Property" type="PropertyType"  minOccurs="0" maxOccurs="unbounded" />
-		</xsd:sequence>
-		<xsd:attribute name="Type" type="xsd:string" use="required"/>
-		<xsd:attribute name="Name" type="xsd:string" use="optional" default="" />
-	</xsd:complexType>
-
-	<xsd:complexType name="AutoWindowType">
-		<xsd:sequence>
-			<xsd:element name="LayoutImport" type="LayoutImportType"  minOccurs="0" maxOccurs="unbounded" />
-			<xsd:element name="Property" type="PropertyType"  minOccurs="0" maxOccurs="unbounded" />
-			<xsd:element name="Event" type="EventType"  minOccurs="0" maxOccurs="unbounded" />
-			<xsd:choice minOccurs="0" maxOccurs="unbounded">
-				<xsd:element name="Window" type="WindowType" />
-				<xsd:element name="AutoWindow" type="AutoWindowType" />
-			</xsd:choice>
-			<xsd:element name="Property" type="PropertyType"  minOccurs="0" maxOccurs="unbounded" />
-		</xsd:sequence>
-		<xsd:attribute name="NameSuffix" type="xsd:string" use="required"/>
-	</xsd:complexType>
-
-	<xsd:complexType name="PropertyType">
-		<xsd:simpleContent>
-			<xsd:extension base="xsd:string">
-				<xsd:attribute name="Name" type="xsd:string" use="required"/>
-				<xsd:attribute name="Value" type="xsd:string" use="optional"/>
-			</xsd:extension>
-		</xsd:simpleContent> 
-	</xsd:complexType>
-
-	<xsd:complexType name="LayoutImportType">
-		<xsd:attribute name="Filename" type="xsd:string" use="required"/>
-		<xsd:attribute name="Prefix" type="xsd:string" use="optional" default="" />
-		<xsd:attribute name="ResourceGroup" type="xsd:string" use="optional"  default="" />
-	</xsd:complexType>
-
-	<xsd:complexType name="EventType">
-		<xsd:attribute name="Name" type="xsd:string" use="required"/>
-		<xsd:attribute name="Function" type="xsd:string" use="required"/>
-	</xsd:complexType>
-
-</xsd:schema>
-
Index: ta/branches/media_stripped/gui/configs/GUIScheme.xsd
===================================================================
--- /data/branches/media_stripped/gui/configs/GUIScheme.xsd	(revision 5591)
+++ 	(revision )
@@ -1,54 +1,0 @@
-<?xml version="1.0" ?>
-<xsd:schema xmlns:xsd="http://www.w3.org/2001/XMLSchema" elementFormDefault="qualified">
-	<xsd:element name="GUIScheme" type="SchemeType" />
-	<xsd:complexType name="SchemeType">
-        <xsd:choice minOccurs="0" maxOccurs="unbounded">
-			<xsd:element name="Imageset" type="NamedDataType" />
-            <xsd:element name="ImagesetFromImage" type="NamedDataType" />
-			<xsd:element name="Font" type="NamedDataType" />
-            <xsd:element name="LookNFeel" type="FileDataType" />
-			<xsd:element name="WindowSet" type="WindowSetType" />
-			<xsd:element name="WindowRendererSet" type="WindowRendererSetType" />
-			<xsd:element name="WindowAlias" type="WindowAliasType" />
-            <xsd:element name="FalagardMapping" type="FalagardMapType" />
-		</xsd:choice>
-		<xsd:attribute name="Name" type="xsd:string" use="required" />
-	</xsd:complexType>
-	<xsd:complexType name="WindowSetType">
-		<xsd:sequence>
-            <xsd:element name="WindowFactory" type="WindowFactoryType" minOccurs="0" maxOccurs="unbounded" />
-		</xsd:sequence>
-		<xsd:attribute name="Filename" type="xsd:string" use="required" />
-	</xsd:complexType>
-	<xsd:complexType name="WindowRendererSetType">
-		<xsd:sequence>
-            <xsd:element name="WindowRendererFactory" type="WindowRendererFactoryType" minOccurs="0" maxOccurs="unbounded" />
-		</xsd:sequence>
-		<xsd:attribute name="Filename" type="xsd:string" use="required" />
-	</xsd:complexType>
-    <xsd:complexType name="FileDataType">
-        <xsd:attribute name="Filename" type="xsd:string" use="required" />
-        <xsd:attribute name="ResourceGroup" type="xsd:string" use="optional"  default="" />
-    </xsd:complexType>
-	<xsd:complexType name="NamedDataType">
-		<xsd:attribute name="Name" type="xsd:string" use="required" />
-		<xsd:attribute name="Filename" type="xsd:string" use="required" />
-		<xsd:attribute name="ResourceGroup" type="xsd:string" use="optional"  default="" />
-	</xsd:complexType>
-	<xsd:complexType name="WindowFactoryType">
-		<xsd:attribute name="Name" type="xsd:string" use="required" />
-	</xsd:complexType>
-	<xsd:complexType name="WindowRendererFactoryType">
-		<xsd:attribute name="Name" type="xsd:string" use="required" />
-	</xsd:complexType>
-	<xsd:complexType name="WindowAliasType">
-		<xsd:attribute name="Alias" type="xsd:string" use="required" />
-		<xsd:attribute name="Target" type="xsd:string" use="required" />
-	</xsd:complexType>
-    <xsd:complexType name="FalagardMapType">
-        <xsd:attribute name="WindowType" type="xsd:string" use="required" />
-        <xsd:attribute name="TargetType" type="xsd:string" use="required" />
-		<xsd:attribute name="Renderer" type="xsd:string" use="required" />
-        <xsd:attribute name="LookNFeel" type="xsd:string" use="required" />
-    </xsd:complexType>
-</xsd:schema>
Index: ta/branches/media_stripped/gui/configs/Imageset.xsd
===================================================================
--- /data/branches/media_stripped/gui/configs/Imageset.xsd	(revision 5591)
+++ 	(revision )
@@ -1,28 +1,0 @@
-<?xml version="1.0"?>
-<xsd:schema xmlns:xsd="http://www.w3.org/2001/XMLSchema" elementFormDefault="qualified">
-
-	<xsd:element name="Imageset" type="ImagesetType"/>
-	
-	<xsd:complexType name="ImagesetType">
-		<xsd:sequence>
-			<xsd:element name="Image" type="ImageType" maxOccurs="unbounded"/>
-		</xsd:sequence>
-		<xsd:attribute name="Imagefile" type="xsd:string" use="required"/>
-		<xsd:attribute name="ResourceGroup" type="xsd:string" use="optional"  default="" />
-		<xsd:attribute name="Name" type="xsd:string" use="required"/>
-		<xsd:attribute name="NativeHorzRes" type="xsd:nonNegativeInteger" use="optional" default="640" />
-		<xsd:attribute name="NativeVertRes" type="xsd:nonNegativeInteger" use="optional" default="480" />
-		<xsd:attribute name="AutoScaled" type="xsd:boolean" use="optional" default="false" />
-	</xsd:complexType>
-	
-	<xsd:complexType name="ImageType">
-		<xsd:attribute name="Name" type="xsd:string" use="required"/>
-		<xsd:attribute name="XPos" type="xsd:nonNegativeInteger" use="required"/>
-		<xsd:attribute name="YPos" type="xsd:nonNegativeInteger" use="required"/>
-		<xsd:attribute name="Width" type="xsd:nonNegativeInteger" use="required"/>
-		<xsd:attribute name="Height" type="xsd:nonNegativeInteger" use="required"/>
-		<xsd:attribute name="XOffset" type="xsd:integer" use="optional" default="0"/>
-		<xsd:attribute name="YOffset" type="xsd:integer" use="optional" default="0"/>						
-	</xsd:complexType>
-
-</xsd:schema>
Index: /data/branches/media_stripped/gui/looknfeel/TaharezLook.looknfeel
===================================================================
--- /data/branches/media_stripped/gui/looknfeel/TaharezLook.looknfeel	(revision 5591)
+++ /data/branches/media_stripped/gui/looknfeel/TaharezLook.looknfeel	(revision 5592)
@@ -1045,10 +1045,20 @@
         <NamedArea name="ProgressArea">
             <Area>
-                <Dim type="LeftEdge" ><ImageDim imageset="TaharezLook" image="ProgressBarLeft" dimension="Width" /></Dim>
+                <Dim type="LeftEdge" >
+                    <ImageDim imageset="TaharezLook" image="ProgressBarLeft" dimension="Width">
+                        <DimOperator op="Divide">
+                            <AbsoluteDim value="2" />
+                        </DimOperator>
+                    </ImageDim>
+                </Dim>
                 <Dim type="TopEdge" ><AbsoluteDim value="0" /></Dim>
                 <Dim type="RightEdge" >
                     <UnifiedDim scale="1" type="RightEdge">
                         <DimOperator op="Subtract">
-                            <ImageDim imageset="TaharezLook" image="ProgressBarRight" dimension="Width" />
+                            <ImageDim imageset="TaharezLook" image="ProgressBarRight" dimension="Width">
+                                <DimOperator op="Divide">
+                                    <AbsoluteDim value="2" />
+                                </DimOperator>
+                            </ImageDim>
                         </DimOperator>
                     </UnifiedDim>
@@ -1068,4 +1078,5 @@
                 <Image type="RightEdge" imageset="TaharezLook" image="ProgressBarRight" />
                 <Image type="Background" imageset="TaharezLook" image="ProgressBarMiddle" />
+                <HorzFormat type="Tiled" />
             </FrameComponent>
         </ImagerySection>