Index: /branches/world_entities/src/Makefile.in
===================================================================
--- /branches/world_entities/src/Makefile.in	(revision 5596)
+++ /branches/world_entities/src/Makefile.in	(revision 5597)
@@ -67,6 +67,7 @@
 	orxonox-aiming_turret.$(OBJEXT) orxonox-test_bullet.$(OBJEXT) \
 	orxonox-rocket.$(OBJEXT) orxonox-laser.$(OBJEXT) \
-	orxonox-aim.$(OBJEXT) orxonox-crosshair.$(OBJEXT) \
-	orxonox-power_up.$(OBJEXT) orxonox-turret_power_up.$(OBJEXT) \
+	orxonox-aim.$(OBJEXT) orxonox-bomb.$(OBJEXT) \
+	orxonox-crosshair.$(OBJEXT) orxonox-power_up.$(OBJEXT) \
+	orxonox-turret_power_up.$(OBJEXT) \
 	orxonox-laser_power_up.$(OBJEXT) orxonox-benchmark.$(OBJEXT)
 orxonox_OBJECTS = $(am_orxonox_OBJECTS)
@@ -262,4 +263,5 @@
                   world_entities/weapons/laser.cc \
                   world_entities/weapons/aim.cc \
+                  world_entities/weapons/bomb.cc \
                   world_entities/weapons/crosshair.cc \
                   world_entities/power_ups/power_up.cc \
@@ -297,4 +299,5 @@
                  world_entities/weapons/laser.h \
                  world_entities/weapons/aim.h \
+                 world_entities/weapons/bomb.h \
                  world_entities/weapons/crosshair.h \
                  world_entities/power_ups/power_up.h \
@@ -400,4 +403,5 @@
 @AMDEP_TRUE@@am__include@ @am__quote@./$(DEPDIR)/orxonox-aiming_turret.Po@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@./$(DEPDIR)/orxonox-benchmark.Po@am__quote@
+@AMDEP_TRUE@@am__include@ @am__quote@./$(DEPDIR)/orxonox-bomb.Po@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@./$(DEPDIR)/orxonox-camera.Po@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@./$(DEPDIR)/orxonox-campaign.Po@am__quote@
@@ -806,4 +810,18 @@
 @AMDEP_TRUE@@am__fastdepCXX_FALSE@	DEPDIR=$(DEPDIR) $(CXXDEPMODE) $(depcomp) @AMDEPBACKSLASH@
 @am__fastdepCXX_FALSE@	$(CXX) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(orxonox_CPPFLAGS) $(CPPFLAGS) $(AM_CXXFLAGS) $(CXXFLAGS) -c -o orxonox-aim.obj `if test -f 'world_entities/weapons/aim.cc'; then $(CYGPATH_W) 'world_entities/weapons/aim.cc'; else $(CYGPATH_W) '$(srcdir)/world_entities/weapons/aim.cc'; fi`
+
+orxonox-bomb.o: world_entities/weapons/bomb.cc
+@am__fastdepCXX_TRUE@	if $(CXX) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(orxonox_CPPFLAGS) $(CPPFLAGS) $(AM_CXXFLAGS) $(CXXFLAGS) -MT orxonox-bomb.o -MD -MP -MF "$(DEPDIR)/orxonox-bomb.Tpo" -c -o orxonox-bomb.o `test -f 'world_entities/weapons/bomb.cc' || echo '$(srcdir)/'`world_entities/weapons/bomb.cc; \
+@am__fastdepCXX_TRUE@	then mv -f "$(DEPDIR)/orxonox-bomb.Tpo" "$(DEPDIR)/orxonox-bomb.Po"; else rm -f "$(DEPDIR)/orxonox-bomb.Tpo"; exit 1; fi
+@AMDEP_TRUE@@am__fastdepCXX_FALSE@	source='world_entities/weapons/bomb.cc' object='orxonox-bomb.o' libtool=no @AMDEPBACKSLASH@
+@AMDEP_TRUE@@am__fastdepCXX_FALSE@	DEPDIR=$(DEPDIR) $(CXXDEPMODE) $(depcomp) @AMDEPBACKSLASH@
+@am__fastdepCXX_FALSE@	$(CXX) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(orxonox_CPPFLAGS) $(CPPFLAGS) $(AM_CXXFLAGS) $(CXXFLAGS) -c -o orxonox-bomb.o `test -f 'world_entities/weapons/bomb.cc' || echo '$(srcdir)/'`world_entities/weapons/bomb.cc
+
+orxonox-bomb.obj: world_entities/weapons/bomb.cc
+@am__fastdepCXX_TRUE@	if $(CXX) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(orxonox_CPPFLAGS) $(CPPFLAGS) $(AM_CXXFLAGS) $(CXXFLAGS) -MT orxonox-bomb.obj -MD -MP -MF "$(DEPDIR)/orxonox-bomb.Tpo" -c -o orxonox-bomb.obj `if test -f 'world_entities/weapons/bomb.cc'; then $(CYGPATH_W) 'world_entities/weapons/bomb.cc'; else $(CYGPATH_W) '$(srcdir)/world_entities/weapons/bomb.cc'; fi`; \
+@am__fastdepCXX_TRUE@	then mv -f "$(DEPDIR)/orxonox-bomb.Tpo" "$(DEPDIR)/orxonox-bomb.Po"; else rm -f "$(DEPDIR)/orxonox-bomb.Tpo"; exit 1; fi
+@AMDEP_TRUE@@am__fastdepCXX_FALSE@	source='world_entities/weapons/bomb.cc' object='orxonox-bomb.obj' libtool=no @AMDEPBACKSLASH@
+@AMDEP_TRUE@@am__fastdepCXX_FALSE@	DEPDIR=$(DEPDIR) $(CXXDEPMODE) $(depcomp) @AMDEPBACKSLASH@
+@am__fastdepCXX_FALSE@	$(CXX) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(orxonox_CPPFLAGS) $(CPPFLAGS) $(AM_CXXFLAGS) $(CXXFLAGS) -c -o orxonox-bomb.obj `if test -f 'world_entities/weapons/bomb.cc'; then $(CYGPATH_W) 'world_entities/weapons/bomb.cc'; else $(CYGPATH_W) '$(srcdir)/world_entities/weapons/bomb.cc'; fi`
 
 orxonox-crosshair.o: world_entities/weapons/crosshair.cc
Index: /branches/world_entities/src/subprojects/importer/Makefile.am
===================================================================
--- /branches/world_entities/src/subprojects/importer/Makefile.am	(revision 5596)
+++ /branches/world_entities/src/subprojects/importer/Makefile.am	(revision 5597)
@@ -31,3 +31,4 @@
                   $(MAINSRCDIR)/lib/util/substring.cc \
                   $(MAINSRCDIR)/lib/util/color.cc \
+                  $(MAINSRCDIR)/lib/util/multi_type.cc \
                   $(MAINSRCDIR)/util/loading/factory.cc
Index: /branches/world_entities/src/subprojects/importer/Makefile.in
===================================================================
--- /branches/world_entities/src/subprojects/importer/Makefile.in	(revision 5596)
+++ /branches/world_entities/src/subprojects/importer/Makefile.in	(revision 5597)
@@ -61,5 +61,5 @@
 	importer-helper_functions.$(OBJEXT) \
 	importer-substring.$(OBJEXT) importer-color.$(OBJEXT) \
-	importer-factory.$(OBJEXT)
+	importer-multi_type.$(OBJEXT) importer-factory.$(OBJEXT)
 importer_OBJECTS = $(am_importer_OBJECTS)
 importer_DEPENDENCIES = $(MAINSRCDIR)/lib/event/libORXevent.a \
@@ -218,4 +218,5 @@
                   $(MAINSRCDIR)/lib/util/substring.cc \
                   $(MAINSRCDIR)/lib/util/color.cc \
+                  $(MAINSRCDIR)/lib/util/multi_type.cc \
                   $(MAINSRCDIR)/util/loading/factory.cc
 
@@ -297,4 +298,5 @@
 @AMDEP_TRUE@@am__include@ @am__quote@./$(DEPDIR)/importer-load_param.Po@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@./$(DEPDIR)/importer-load_param_description.Po@am__quote@
+@AMDEP_TRUE@@am__include@ @am__quote@./$(DEPDIR)/importer-multi_type.Po@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@./$(DEPDIR)/importer-null_parent.Po@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@./$(DEPDIR)/importer-p_node.Po@am__quote@
@@ -541,4 +543,18 @@
 @AMDEP_TRUE@@am__fastdepCXX_FALSE@	DEPDIR=$(DEPDIR) $(CXXDEPMODE) $(depcomp) @AMDEPBACKSLASH@
 @am__fastdepCXX_FALSE@	$(CXX) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(importer_CPPFLAGS) $(CPPFLAGS) $(AM_CXXFLAGS) $(CXXFLAGS) -c -o importer-color.obj `if test -f '$(MAINSRCDIR)/lib/util/color.cc'; then $(CYGPATH_W) '$(MAINSRCDIR)/lib/util/color.cc'; else $(CYGPATH_W) '$(srcdir)/$(MAINSRCDIR)/lib/util/color.cc'; fi`
+
+importer-multi_type.o: $(MAINSRCDIR)/lib/util/multi_type.cc
+@am__fastdepCXX_TRUE@	if $(CXX) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(importer_CPPFLAGS) $(CPPFLAGS) $(AM_CXXFLAGS) $(CXXFLAGS) -MT importer-multi_type.o -MD -MP -MF "$(DEPDIR)/importer-multi_type.Tpo" -c -o importer-multi_type.o `test -f '$(MAINSRCDIR)/lib/util/multi_type.cc' || echo '$(srcdir)/'`$(MAINSRCDIR)/lib/util/multi_type.cc; \
+@am__fastdepCXX_TRUE@	then mv -f "$(DEPDIR)/importer-multi_type.Tpo" "$(DEPDIR)/importer-multi_type.Po"; else rm -f "$(DEPDIR)/importer-multi_type.Tpo"; exit 1; fi
+@AMDEP_TRUE@@am__fastdepCXX_FALSE@	source='$(MAINSRCDIR)/lib/util/multi_type.cc' object='importer-multi_type.o' libtool=no @AMDEPBACKSLASH@
+@AMDEP_TRUE@@am__fastdepCXX_FALSE@	DEPDIR=$(DEPDIR) $(CXXDEPMODE) $(depcomp) @AMDEPBACKSLASH@
+@am__fastdepCXX_FALSE@	$(CXX) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(importer_CPPFLAGS) $(CPPFLAGS) $(AM_CXXFLAGS) $(CXXFLAGS) -c -o importer-multi_type.o `test -f '$(MAINSRCDIR)/lib/util/multi_type.cc' || echo '$(srcdir)/'`$(MAINSRCDIR)/lib/util/multi_type.cc
+
+importer-multi_type.obj: $(MAINSRCDIR)/lib/util/multi_type.cc
+@am__fastdepCXX_TRUE@	if $(CXX) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(importer_CPPFLAGS) $(CPPFLAGS) $(AM_CXXFLAGS) $(CXXFLAGS) -MT importer-multi_type.obj -MD -MP -MF "$(DEPDIR)/importer-multi_type.Tpo" -c -o importer-multi_type.obj `if test -f '$(MAINSRCDIR)/lib/util/multi_type.cc'; then $(CYGPATH_W) '$(MAINSRCDIR)/lib/util/multi_type.cc'; else $(CYGPATH_W) '$(srcdir)/$(MAINSRCDIR)/lib/util/multi_type.cc'; fi`; \
+@am__fastdepCXX_TRUE@	then mv -f "$(DEPDIR)/importer-multi_type.Tpo" "$(DEPDIR)/importer-multi_type.Po"; else rm -f "$(DEPDIR)/importer-multi_type.Tpo"; exit 1; fi
+@AMDEP_TRUE@@am__fastdepCXX_FALSE@	source='$(MAINSRCDIR)/lib/util/multi_type.cc' object='importer-multi_type.obj' libtool=no @AMDEPBACKSLASH@
+@AMDEP_TRUE@@am__fastdepCXX_FALSE@	DEPDIR=$(DEPDIR) $(CXXDEPMODE) $(depcomp) @AMDEPBACKSLASH@
+@am__fastdepCXX_FALSE@	$(CXX) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(importer_CPPFLAGS) $(CPPFLAGS) $(AM_CXXFLAGS) $(CXXFLAGS) -c -o importer-multi_type.obj `if test -f '$(MAINSRCDIR)/lib/util/multi_type.cc'; then $(CYGPATH_W) '$(MAINSRCDIR)/lib/util/multi_type.cc'; else $(CYGPATH_W) '$(srcdir)/$(MAINSRCDIR)/lib/util/multi_type.cc'; fi`
 
 importer-factory.o: $(MAINSRCDIR)/util/loading/factory.cc